//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben 	 	*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
void WriteRTL (char,char);
unsigned char ReadRTL (char);
void Init_Realtek_Network_Card (void);
void Write_Ethernet_Frame (char *,unsigned int);
void Read_Ethernet_Frame (char *,unsigned int *);

#define nop()  __asm__ __volatile__ ("nop" ::)

//Ethernet Card Ports
#define DATA_CTRL_RLT  			DDRA
#define DATA_ADDR_RLT			DDRC	//Fr ATMega128/32 wird bei ATMega102 nicht bentigt
#define ADDR_PORT_RLT  			PORTC
#define DATA_PORT_RLT_WRITE  	PORTA
#define DATA_PORT_RLT_READ 		PINA	//Read
#define WRITE_PIN				6		//gibt den Pin an wo der WriteIO Signal angeschlossen ist
#define READ_PIN				5		//gibt den Pin an wo der ReadIO Signal angeschlossen ist
#define RESET_PIN				7		//gibt den Pin an wo der Reset angeschlossen ist
#define INPUT					0x00	//setzt einen Port auf Input
#define OUTPUT					0xff	//setzt einen Port auf Output

//Realtek Netzwerkkarten Register
#define CR						0x00
#define PSTART					0x01
#define PAR0					0x01                                          
#define PSTOP					0x02
#define BNRY					0x03
#define TPSR					0x04
#define TBCR0					0x05
#define TBCR1					0x06
#define ISR						0x07
#define CURR					0x07                                       
#define RSAR0					0x08
#define CRDA0					0x08
#define RSAR1					0x09	
#define CRDAl					0x09
#define RBCR0					0x0A
#define RBCR1					0x0B
#define RSR						0x0C
#define RCR						0x0C
#define TCR						0x0D
#define CNTR0					0x0D
#define DCR						0x0E
#define CNTR1					0x0E
#define IMR						0x0F
#define CNTR2					0x0F
#define RDMAPORT				0x10
#define RSTPORT					0x18
//RTL8019AS initial register Werte
#define RCRVAL					0x04
#define TCRVAL					0x00
#define DCRVAL					0x58
//PXR and OVW interrupt enabled
#define IMRVAL					0x11
#define TXSTART					0x40
#define RXSTART					0x46
#define RXSTOP					0x60
//RTL8019AS ISR Register Bits
#define RST						7
#define RDC						6
#define OVW						4
#define PRX						0

